//SpiraleEinfach_402d.js
// 08.01.14 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Zeichnet eine Spirale

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// testen, ob ein Objekt ausgewhlt ist
if (app.selection.length == 0) {
	alert ("Bitte einen Rahmen auswhlen.", "Achtung");
	exit();
}

// das aktuelle Dokument
var curDoc = app.documents[0];

// Masseinheiten, Linealursprung und Nullpunkt speichern
hM = curDoc.viewPreferences.horizontalMeasurementUnits;
vM = curDoc.viewPreferences.verticalMeasurementUnits;
rO = curDoc.viewPreferences.rulerOrigin;
zP = curDoc.zeroPoint;
tR = curDoc.layoutWindows[0].transformReferencePoint;

// Einstellungen ndern
curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
curDoc.viewPreferences.rulerOrigin = RulerOrigin.SPREAD_ORIGIN;
curDoc.zeroPoint = [0,0];
curDoc.layoutWindows[0].transformReferencePoint = AnchorPoint.topLeftAnchor;

// die Abmessungen der Auswahl speichern
try {
	var gB = app.selection[0].geometricBounds;
}
catch (e) {
	alert ("Bitte einen rechteckigen Rahmen auswhlen.", "Stop");
	reStoreSettings();
	exit();
}

// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
var allPrefs = getPrefs();
ck01 = ck02 = ck03 = ck04 = 0;
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	strW = prefVal[0]*1;
	strT = prefVal[1]*1;
	dstV = prefVal[2]*1;
	rb01 = prefVal[3]*1;
	if (rb01 == 0) {
		ck01 = 1;
	}
	else {
		ck02 = 1;
	}
	delV = prefVal[4]*1;
	rb02 = prefVal[5]*1;
	if (rb02 == 0) {
		ck03 = 1;
	}
	else {
		ck04 = 1;
	}
}
else {
	// wenn die Prferenzen-Datei nicht gefunden wurde
	// dann auf die Vorgabenwerte zurckgreifen
	strW = 1;
	strT = 100;
	dstV = 5;
	ck01 = 1;
	ck02 = 0;
	delV = 0;
	ck03 = 1;
	ck04 = 0;
}

// die Funktion aufrufen, welche den Dialog zeigt und das Ergebnis zurckgibt
var anArray  = displayDialog();
var strW     = anArray[0];
var strT     = anArray[1];
var distVal  = anArray[2];
var precDec  = anArray[3];
var delVal   = anArray[4];
var dirDec   = anArray[5];

// die halbe Distanz
var halfDst = distVal/2;

// die Positionen y1, x1, p2 ("p", wie przise; wenn die przise Breite gefragt ist) 
var y1 = (Math.floor((gB[0]*1000)+0.5))/1000;
var x1 = (Math.floor((gB[1]*1000)+0.5))/1000;
var p2 = (Math.floor((gB[3]*1000)+0.5))/1000;

// die Breite des Rahmens mit dem Abstandswert vergleichen
if ((p2-x1) <= distVal) {
	alert ("Der Musterrahmen ist nicht breit genug.\nMindest-Breite = " + (distVal+0.1) + " mm", "Stop");
	reStoreSettings();
	exit();
}

// die Anzahl Halbkreise errechnen
var nFrames = Math.ceil((p2-x1)/(distVal));

// den x2-Wert neu berechnen
var x2 = x1+(nFrames*distVal);

// die Position y2
var y2 = y1+(x2-x1);

// vergleichen mit den zu entfernenden Viertelkreisen
if (delVal >= nFrames*2) {
	var maxVal = (nFrames*2)-1;
	alert ("Maximal " + maxVal + " Viertelkreise sind zu entfernen.\n" + delVal + " ist ein zu grosser Wert.", "Stop");
	reStoreSettings();
	exit();
}

// die Anzahl Runden ausrechnen
var nRounds = Math.ceil(nFrames/2);

// die vertikale Mitte des Objekts
var m1 = y1 + (y2-y1);

// einen Array vorbereiten
var allFrames = new Array ();

// einen kreisfrmigen Rahmen erzeugen ...
var baseOne = app.activeWindow.activePage.ovals.add();
baseOne.properties = {geometricBounds:[y1, x1, y2, x2], fillColor:"None", strokeColor:"None"};
// ... und an den Array anfgen
allFrames.push(baseOne);

// den Pfad ffnen
baseOne.paths[0].pathType = PathType.OPEN_PATH;

// den ersten Pfadpunkt entfernen; Ergebnis: ein Halbkreis
baseOne.paths[0].pathPoints[0].remove();

// den Halbkreis duplizieren ...
var baseTwo = baseOne.duplicate(undefined, [0, y2-y1]);
// ... und an den Array anfgen
allFrames.push(baseTwo);

// die Kopie spiegeln
baseTwo.flipItem(Flip.VERTICAL);

// die Kopie verkleinern
var gB = baseTwo.geometricBounds; 
baseTwo.geometricBounds = [gB[0], gB[1], gB[2]-halfDst, gB[3]-distVal];

// in einer Schleife die Basis-Halbkreise duplizieren und verkleinern
for (var n=0; n<nRounds-1; n++) {

	// den ersten Halbkreis duplizieren ...
	var newFrame = baseOne.duplicate([x1, y1]);
	// ... und an den Array anfgen
	allFrames.push(newFrame);
	
	// die Kopie verkleinern
	var gB = newFrame.geometricBounds; 
	newFrame.geometricBounds = [gB[0]+(distVal*(n+1)), gB[1]+distVal*(n+1), gB[2], gB[3]-distVal*(n+1)];
	
	try {
		// den zweiten Halbkreis duplizieren
		var newFrame = baseTwo.duplicate([x1, m1-halfDst]);
		
		// die Kopie verkleinern ...
		var gB = newFrame.geometricBounds; 
		newFrame.geometricBounds = [gB[0], gB[1]+distVal*(n+1), gB[2]-(distVal*(n+1)), gB[3]-distVal*(n+1)];
	// ... und an den Array anfgen
		allFrames.push(newFrame);
	}
	catch (e) {
		newFrame.remove();
	}
}

// die Endpunkte verbinden
for (var n=1; n<allFrames.length; n++) {
	if (n%2 == 0) {
		try {
			allFrames[0].paths[0].pathPoints[n*2].join(allFrames[n].paths[0].pathPoints[0], JoinOptions.COMBINE);
		}
		catch (e) {
		}
	}
	else {
		try {
			allFrames[0].paths[0].pathPoints[n*2].join(allFrames[n].paths[0].pathPoints[2], JoinOptions.COMBINE);
		}
		catch (e) {
		}
	}
}

// Abstnde przise; oder genau auf Musterrahmen-Breite
if (precDec == 0) {
	var precPre = "";
	var precTxt = "przise, wie definiert";
}
else if (precDec == 1) {
	if (p2 != x2) {
		var precPre = "ca. ";
	}
	else {
		var precPre = "";
	}
	var precTxt = "Objekt-Breite: wie Musterrahmen";
	var gB = allFrames[0].geometricBounds;
	var scaleVal = (p2-gB[1])/(gB[3]-gB[1]);
	y2 = gB[0]+((gB[2]-gB[0])*scaleVal);
	allFrames[0].geometricBounds = [gB[0], gB[1], y2, p2];
}

// der Kontur ein paar Attribute zuweisen
allFrames[0].properties = {strokeColor:"Black", strokeWeight:strW, strokeTint:strT, 
		strokeAlignment:StrokeAlignment.CENTER_ALIGNMENT, endCap:EndCap.ROUND_END_CAP};

// die Richtung umkehren
allFrames[0].paths[0].reverse ();

// wenn gewnscht, Viertelkreise entfernen
for (var v=0; v<delVal; v++) {
	allFrames[0].paths[0].pathPoints[0].remove();
}

// "im Uhrzeigersinn" (= Vorgabe) oder "gegen den Uhrzeigersinn"
if (dirDec == 0) {
	var dirTxt = "im Uhrzeigersinn";
}
else if (dirDec == 1) {
	var dirTxt = "gegen den Uhrzeigersinn";
	// Bezugspunkt in der Mitte auswhlen
	curDoc.layoutWindows[0].transformReferencePoint = AnchorPoint.centerAnchor;
	// die Spirale spiegeln
	allFrames[0].flipItem(Flip.VERTICAL);
}

// den Eintrag ins Etikett vornehmen
allFrames[0].label = "Konturen-Abstnde: " + precPre + distVal + " mm\r\n" + precTxt+ "\r\nInnen " + delVal + " Viertelkreise entfernt\r\nRichtung: " + dirTxt;

// die Funktion zum Zurcksetzen der Einstellungen aufrufen
reStoreSettings();


////////////////////////////// die Funktionen  ////////////////////////////////////////////////////

// die Funktion, welche die Informationen vorbereitet /////////////////////////////////////////////
function getPrefs() {
	var allPrefs = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/SpiraleEinfach401.txt");
	}
	else {
		var f = new File("~/Library/Preferences/SpiraleEinfach401.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// den Dialog vorbereiten und anzeigen ////////////////////////////////////////////////////////////
function displayDialog() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth = 120;
	var fieldWidth =  36;
	var aDialog = app.dialogs.add({name:"SpiraleEinfach"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Kontur-Strke:", minWidth:labelWidth-10});
						var weightField = realEditboxes.add({editValue:strW, minimumValue:0.1, maximumValue:99, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"pt", minWidth:12});
						staticTexts.add({staticLabel:" ", minWidth:13});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Kontur-Tonwert:", minWidth:labelWidth-10});
						var tintField = realEditboxes.add({editValue:strT, minimumValue:1, maximumValue:100, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"%", minWidth:12});
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Konturen-Abstand:", minWidth:labelWidth-10});
						var distField = realEditboxes.add({editValue:dstV, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"mm", minWidth:12});
						staticTexts.add({staticLabel:"", minWidth:5});
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:24});
							staticTexts.add({staticLabel:"a) Konturen-Abstnde ..."});
							staticTexts.add({staticLabel:" ", minWidth:9});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"oder b) Objekt-Breite?"});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:8});
							with(precButtons = radiobuttonGroups.add()){
								radiobuttonControls.add({staticLabel:"a) przise, wie definiert", checkedState:ck01});
								radiobuttonControls.add({staticLabel:"b) exakt wie Musterrahmen", checkedState:ck02});
							}
						}
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Innen"});
				var delField = integerEditboxes.add({editValue:delV, minimumValue:0, maximumValue:9999, minWidth:fieldWidth, });
				staticTexts.add({staticLabel:"Viertelkreise entfernen"});
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Laufrichtung:", minWidth:50});
						staticTexts.add({staticLabel:" ", minWidth:109});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" ", minWidth:8});
						with(dirButtons = radiobuttonGroups.add()){
							radiobuttonControls.add({staticLabel:"im Uhrzeigersinn", checkedState:ck03});
							radiobuttonControls.add({staticLabel:"gegen den Uhrzeigersinn", checkedState:ck04});
						}
					}
				}
			}
		}
	}
	if(aDialog.show() == true) {
		// die Eingaben auswerten
		var strWght = weightField.editValue;
		var strTint = tintField.editValue;
		var distVal = distField.editValue;
		var precDec = precButtons.selectedButton;
		var delVal  = delField.editValue;
		var dirDec  = dirButtons.selectedButton;
		// den Dialog entfernen
		aDialog.destroy();
		// die neue Vorgabenliste
		var prefsList = new Array (strWght, strTint, distVal, precDec, delVal, dirDec);
		// in eine Textkette verwandeln
		var prefString = prefsList.join("\n");
		// zur Funktion schicken, welche das Ergebnis in eine Datei schreibt
		writeResult(prefString);
		if (distVal == 0) {
			alert ("Der Abstandswert ist Null.\nBitte nochmals.", "Stop");
			reStoreSettings();
			exit();
		}
		// das Ergebnis zum Aufruf zurckschicken
		return [strWght, strTint, distVal, precDec, delVal, dirDec];
	}
	else{
		// wenn "Abbrechen", den Dialog entfernen ...
		aDialog.destroy();
		// ... die Funktion aufrufen, welche die Einstellungen zurcksetzt ...
		reStoreSettings();
		// ... und die Ausfhrung abbrechen
		exit();
	}
}

// das Ergebnis in eine Datei schreiben ///////////////////////////////////////////////////////////
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/SpiraleEinfach401.txt");
	}
	else {
		var f = File("~/Library/Preferences/SpiraleEinfach401.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// eventuell genderte Einstellungen zurcksetzen /////////////////////////////////////////////////
function reStoreSettings() {
	// Masseinheiten, Linealursprung und Nullpunkt zurcksetzen
	curDoc.viewPreferences.horizontalMeasurementUnits = hM;
	curDoc.viewPreferences.verticalMeasurementUnits = vM;
	curDoc.viewPreferences.rulerOrigin = rO;
	curDoc.zeroPoint = zP;
	curDoc.layoutWindows[0].transformReferencePoint = tR;
}